/**
 * Copyright by Manuel Siekmann (makasy.com)
 * The License.txt file describes the conditions under which this software may be distributed.
 * @author Manuel Siekmann
 * @version 1.0
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.metal.MetalLookAndFeel;

public class ChainLogin extends JPanel {
    JTextField mySessionText;
    JPasswordField myPasswordText;
    JLabel mySessionLabel;
    JLabel myPasswordLabel;
    JButton myLoginButton;
    JButton myCancelButton;
	JLabel myMessage;
	
	final Color INPUT_BACK_COLOR = new Color(22,22,22);
	final Color BACK_COLOR = new Color(44,44,44);
	final Color TEXT_COLOR = new Color(255,255,255);
	final Color BORDER_COLOR = new Color(99,99,99);
	
    public ChainLogin(ActionListener listener) {
		super(new GridBagLayout());
		try { 
			UIManager.setLookAndFeel(new MetalLookAndFeel());
		} catch(Exception e) {
			e.printStackTrace();
		}
		JPanel tmpLogin = new JPanel(new GridBagLayout());
        JPanel tmpPanel = new JPanel(new GridBagLayout());
		JPanel tmpBorderPanel = null;
        GridBagConstraints tmpGridBag = new GridBagConstraints();
        tmpGridBag.fill = GridBagConstraints.NONE;
		tmpGridBag.anchor = GridBagConstraints.WEST;

		tmpPanel.setBorder(new TitledBorder(new LineBorder(BORDER_COLOR, 1, false), "Spiel erstellen", 0, 0, null, BORDER_COLOR) );
		myMessage = new JLabel("Bitte einloggen ....");
		myMessage.setForeground(new Color(200,50,50));
		
		tmpGridBag.ipadx = 30;
		tmpGridBag.ipady = 5;
        mySessionLabel = new JLabel("Name:  ");
        tmpGridBag.gridx = 0;
		tmpGridBag.gridy = 1;
        tmpGridBag.gridwidth = 1;
		mySessionLabel.setBorder(new EmptyBorder(0,15,0,0));
        tmpPanel.add(mySessionLabel, tmpGridBag);

        myPasswordLabel = new JLabel("Passwort:  ");
        tmpGridBag.gridx = 0;
        tmpGridBag.gridy = 2;
        tmpGridBag.gridwidth = 1;
		myPasswordLabel.setBorder(new EmptyBorder(0,15,0,0));
        tmpPanel.add(myPasswordLabel, tmpGridBag);

		tmpGridBag.ipadx = 20;
		
        mySessionText = new JTextField(20);
        tmpGridBag.gridx = 1;
        tmpGridBag.gridy = 1;
        tmpGridBag.gridwidth = 2;
		tmpBorderPanel = new JPanel();

		tmpBorderPanel.add(mySessionText);
		tmpBorderPanel.setOpaque(false);
        tmpPanel.add(tmpBorderPanel, tmpGridBag);
		
        myPasswordText = new JPasswordField(20);
        tmpGridBag.gridx = 1;
        tmpGridBag.gridy = 2;
        tmpGridBag.gridwidth = 2;
		tmpBorderPanel = new JPanel();

		tmpBorderPanel.add(myPasswordText);
		tmpBorderPanel.setOpaque(false);
        tmpPanel.add(tmpBorderPanel, tmpGridBag);

        myLoginButton = new JButton("Erstellen");
		myLoginButton.addActionListener(listener);
		myLoginButton.setFocusPainted(false);
		myLoginButton.setContentAreaFilled(false);
		
        myCancelButton = new JButton("Beenden");
		myCancelButton.setFocusPainted(false);
		myCancelButton.setContentAreaFilled(false);
        myCancelButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });
		
        JPanel tmpButtonPanel = new JPanel();
        tmpButtonPanel.add(myLoginButton);
        tmpButtonPanel.add(myCancelButton);
		
		tmpGridBag.ipady = 40;
        tmpGridBag.gridx = 0;
		tmpGridBag.gridy = 0;
		tmpGridBag.anchor = GridBagConstraints.CENTER;
        tmpLogin.add(myMessage, tmpGridBag);
		
		tmpGridBag.ipady = 40;
        tmpGridBag.gridx = 0;
		tmpGridBag.gridy = 1;
		tmpGridBag.anchor = GridBagConstraints.WEST;
        tmpLogin.add(tmpPanel, tmpGridBag);

		tmpGridBag.ipady = 40;
        tmpGridBag.gridx = 0;
		tmpGridBag.gridy = 2;
		tmpGridBag.ipadx = 0;
		tmpGridBag.anchor = GridBagConstraints.EAST;
        tmpLogin.add(tmpButtonPanel, tmpGridBag);

        tmpGridBag.gridx = 0;
		tmpGridBag.gridy = 0;
		tmpGridBag.anchor = GridBagConstraints.CENTER;
		add(tmpLogin, tmpGridBag);
		
		mySessionText.setText("TestGame");
		mySessionText.setForeground(TEXT_COLOR);
		myPasswordText.setForeground(TEXT_COLOR);
		
		mySessionLabel.setForeground(TEXT_COLOR);
		myPasswordLabel.setForeground(TEXT_COLOR);
		this.setBackground(BACK_COLOR);
		
		tmpLogin.setBackground(BACK_COLOR);
		tmpPanel.setBackground(BACK_COLOR);	
		tmpButtonPanel.setBackground(BACK_COLOR);		
				
		mySessionText.setBackground(INPUT_BACK_COLOR);
		myPasswordText.setBackground(INPUT_BACK_COLOR);
		mySessionText.setForeground(TEXT_COLOR);
		myPasswordText.setForeground(TEXT_COLOR);

		mySessionText.setBorder(new CompoundBorder(new LineBorder(BORDER_COLOR, 1, false), new EmptyBorder(3,3,3,3)));
		myPasswordText.setBorder(new CompoundBorder(new LineBorder(BORDER_COLOR, 1, false), new EmptyBorder(3,3,3,3)));
		
		mySessionText.setMaximumSize(new Dimension(400,10));
		myPasswordText.setMaximumSize(new Dimension(400,10));
		
		myLoginButton.setBackground(BACK_COLOR);
		myCancelButton.setBackground(BACK_COLOR);
		myLoginButton.setForeground(TEXT_COLOR);
		myCancelButton.setForeground(TEXT_COLOR);
		myLoginButton.setOpaque(true);
		myCancelButton.setOpaque(true);
		
		
    }

	public void setText(String value) {
		myMessage.setText(value);
	}
	
    public String getSessionName() {
        return mySessionText.getText().trim();
    }
	
    public String getPassword() {
        return new String(myPasswordText.getPassword());
    }

}