/**
 * Copyright by Manuel Siekmann (makasy.com)
 * The License.txt file describes the conditions under which this software may be distributed.
 * @author Manuel Siekmann
 * @version 1.0
 */
import java.awt.*;
import java.util.Vector;
import javax.swing.*;

public class ChainPitchPanel extends JPanel {
	IChainPitchUI myOwner = null;
	Vector<IChainField> myFields = null;
	int myOffset = -1;

	public void init(IChainPitchUI owner) {
		myOwner = owner;
	}

	public void setFields(Vector<IChainField> fields, int offset) {
		myFields = fields;
		myOffset = offset;
	}
	
    public void paint(Graphics g) {
		super.paint(g);
		if (myFields != null) {
			for (IChainField tmpField : myFields) {
				IChainFieldUI tmpFieldUI = (IChainFieldUI)tmpField;
				tmpFieldUI.drawAtoms(g, tmpFieldUI.getX(), tmpFieldUI.getY(), myOffset);
			}
		}
	}

}


