/**
 * Copyright by Manuel Siekmann (makasy.com)
 * The License.txt file describes the conditions under which this software may be distributed.
 * @author Manuel Siekmann
 * @version 1.0
 */
public interface IChainSession {

	public IChainPitch getPitch();

	public boolean addPlayer(IChainChannel playerChannel);

	public int getPlayerID(IChainChannel playerChannel);

	public void shiftPlayer();

	public boolean checkCurrentPlayer(IChainChannel playerChannel);

	public int getPlayerCount();

	public boolean send(ChainMessage message);

	public void start();

	public void close(String message);

	public boolean isStarted();

	public boolean isPasswordValid(String password);

	public boolean isSizeValid(int sizeX, int sizeY);

	public String getName();
}